import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.event.*;

/**
 * <b>Programm:</b> ComplexCalc<br>
 * <b>Copyright:</b> 2002 Andreas Gohr, Frank Schubert<br>
 * <b>License:</b> GPL2 or higher<br>
 * <br>
 * <b>Info:</b> Main class, implements all needed listeners
 */
public class ComplexCalc extends JFrame
                      implements ActionListener,
                                 MouseListener,
                                 FocusListener {
  Diagram    _dia = null;
  InputPanel  _ip = null;
  
  /**
   * Constructor
   */
  public ComplexCalc(){
    setTitle("ComplexCalc");
    setSize(240,310);
    addWindowListener(new WindowCallback()); //close window on X

    _ip = new InputPanel(this,this);
    _dia = new Diagram(this);

    getContentPane().setLayout(new BorderLayout());
    getContentPane().add(_dia, BorderLayout.CENTER);
    getContentPane().add(_ip, BorderLayout.SOUTH);
  }

  /**
   * Main routine - no args are used
   */
  public static void main(String Args[]) {
    ComplexCalc ic = new ComplexCalc();
    ic.setVisible(true);
  }

  /**
   * Eventhandler (ActionListener) for buttonpresses
   */
  public void actionPerformed(ActionEvent e){
    _dia.setOp(e.getActionCommand());
    System.err.println("boo");
  }

  /**
   * Eventhandler (MouseListener) for clicks inside the diagram
   */
  public void mouseClicked(MouseEvent e){
    ComplexNumber cn = new ComplexNumber(_dia.i2eX(e.getX()),_dia.i2eY(e.getY()));
    //System.err.println(e.getX()+" "+e.getY()+" "+e.getButton()+" -> "+cn.toString());
    
    if(e.getButton() == 1){
      //set 1st vector
      _dia.setVal1(cn);
      _ip.setTf1(cn.toString());
    }else{
      //set 2nd vector
      _dia.setVal2(cn);
      _ip.setTf2(cn.toString());
    }
  }
  /** not implemented */
  public void mousePressed(MouseEvent e){}
  /** not implemented */
  public void mouseReleased(MouseEvent e){}
  /** not implemented */
  public void mouseEntered(MouseEvent e){}
  /** not implemented */
  public void mouseExited(MouseEvent e){}


  /**
   * Eventhandler (FocusListener) for textfield focus changes
   */
  public void focusLost(FocusEvent e){
    //System.err.println("focus lost");
    JTextField tf = (JTextField) e.getComponent();
    ComplexNumber cn = new ComplexNumber(tf.getText());
    tf.setText(cn.toString());
    if(tf.getName() == "tf1"){
      _dia.setVal1(cn);
    }else if(tf.getName() == "tf2"){
      _dia.setVal2(cn);
    }
    //System.err.println(tf.getName());
  }
  
  /** not implemented */
  public void focusGained(FocusEvent e){}  
}


/**
 * Callback class to exit application on windowclose
 */
class WindowCallback extends WindowAdapter {
  public void windowClosing(WindowEvent e){
    System.exit(0);
  }
}
