import java.util.regex.*;

/**
 * <b>Programm:</b> ComplexCalc<br>
 * <b>Copyright:</b> 2002 Frank Schubert, Andreas Gohr<br>
 * <b>License:</b> GPL2 or higher<br>
 * <br>
 * <b>Info:</b> Complex number calculations
 */
public class ComplexNumber {
  private Double re,im;
  
  /**
   * dummy constructor
   */
  public ComplexNumber() {
    this.re = new Double(0);
    this.im = new Double(0);
  }
  
  /**
   * constructor
   */
  public ComplexNumber(double re,double im) {
    this.re = new Double(re);
    this.im = new Double(im);
  }

  /**
   * constructor #2
   */
  public ComplexNumber(String str) {
	  this.re = new Double(0);
    this.im = new Double(0);
    
    if(str.length()==0) str=new String("");
    
    Pattern p=Pattern.compile("([+-]?)([0-9]+\\.[0-9]+|[0-9]*)([+-]?)([0-9]+\\.[0-9]+|[0-9]*)(i?)");
    Matcher m=p.matcher(str);
    boolean result=m.matches();
    
    if(result==true) {
      /* wenn i fehlt -> reell */
      if(m.group(5).length()==0) {
        this.re = new Double(m.group(1)+m.group(2));
        this.im = new Double(0);
      }
      /* wenn i vorhanden und 3 nicht vorhanden -> im */
      if((m.group(5).compareTo("i")==0) && (m.group(3).length()==0)) {
        this.re = new Double(0);
        this.im = new Double(m.group(1)+m.group(2));
      }
      if((m.group(2).length()!=0) &&
         (m.group(3).length()!=0) &&
         (m.group(5).compareTo("i")==0)) {
        this.re=new Double(m.group(1)+m.group(2));
        this.im=new Double(m.group(3)+m.group(4));
      }
    }
  }
  
  public double getRe() {
    return re.doubleValue();
  }
  
  public double getIm() {
    return im.doubleValue();
  }
  
  public String toString() {
    String temp_str=new String("");
    if(im.compareTo(new Double(0.0))>=0) { temp_str = new String("+"+im.toString()); }
    else { temp_str = new String(im.toString()); }
    String str= new String(re.toString() + temp_str + "i");
    return str;
  }
  
  public ComplexNumber add(ComplexNumber i) {
    return(new ComplexNumber(this.getRe()+i.getRe(),
			     this.getIm()+i.getIm()));
  }
  
  public ComplexNumber sub(ComplexNumber i) {
    return(new ComplexNumber(this.getRe()-i.getRe(),
           this.getIm()-i.getIm()));
  }
  
  public ComplexNumber mul(ComplexNumber i) {
    double a1 = this.getRe();
    double a2 = i.getRe();
    double b1 = this.getIm();
    double b2 = i.getIm();
    
    return(new ComplexNumber(a1*a2-b1*b2,a1*b2+a2*b1));
  }
  
  public ComplexNumber div(ComplexNumber i) {
    double a1 = this.getRe();
    double a2 = i.getRe();
    double b1 = this.getIm();
    double b2 = i.getIm();
    
    double temp_re =  (a1*a2+b1+b2)/(a2*a2+b2*b2);
    double temp_im = (-a1*b2+a2*b1)/(a2*a2+b2*b2);
    
    return(new ComplexNumber(temp_re,temp_im));
  }
}
