import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * <b>Programm:</b> ComplexCalc<br>
 * <b>Copyright:</b> 2002 Andreas Gohr, Frank Schubert<br>
 * <b>License:</b> GPL2 or higher<br>
 * <br>
 * <b>Info:</b> JPanel class that provides the input controls for ComplexCalc
 */
public class InputPanel extends JPanel{
  JTextField _tf1;
  JTextField _tf2;

  /**
   * Constructor
   */
  public InputPanel(ActionListener al, FocusListener fl){
    setLayout(new GridLayout(2,1));
    JPanel p1 = new JPanel();
    JPanel p2 = new JPanel();
  
    JButton op_plus     = new JButton("+");
    op_plus.setActionCommand("+");
    op_plus.addActionListener(al);
    JButton op_minus    = new JButton("-");
    op_minus.setActionCommand("-");
    op_minus.addActionListener(al);
    JButton op_divide   = new JButton("/");
    op_divide.setActionCommand("/");
    op_divide.addActionListener(al);
    JButton op_multiply = new JButton("*");
    op_multiply.setActionCommand("*");
    op_multiply.addActionListener(al);
    _tf1 = new JTextField("0.0+0.0i",8);
    _tf1.addFocusListener(fl);
    _tf1.setName("tf1");
    _tf2 = new JTextField("0.0+0.0i",8);
    _tf2.addFocusListener(fl);
    _tf2.setName("tf2");

    p1.add(_tf1);
    p1.add(_tf2);
    
    p2.add(op_plus);
    p2.add(op_minus);
    p2.add(op_divide);
    p2.add(op_multiply);

    add(p1);
    add(p2);
  }

  /**
   * Sets the value of the first Textfield
   */
  public void setTf1(String text){
    _tf1.setText(text);
  }
  
  /**
   * Sets the value of the second Textfield
   */
  public void setTf2(String text){
    _tf2.setText(text);
  }
}
